import { SelectionSetNode } from 'graphql';
import { Reference, StoreObject } from '../../utilities';
import { Cache } from '../core/types/Cache';
import { DiffQueryAgainstStoreOptions, ReadMergeModifyContext } from './types';
import { InMemoryCache } from './inMemoryCache';
import { MissingFieldError } from '../core/types/common';
export declare type VariableMap = {
    [name: string]: any;
};
export declare type ExecResult<R = any> = {
    result: R;
    missing?: MissingFieldError[];
};
export interface StoreReaderConfig {
    cache: InMemoryCache;
    addTypename?: boolean;
    resultCacheMaxSize?: number;
}
export declare class StoreReader {
    private config;
    private executeSelectionSet;
    private executeSubSelectedArray;
    constructor(config: StoreReaderConfig);
    diffQueryAgainstStore<T>({ store, query, rootId, variables, returnPartialData, }: DiffQueryAgainstStoreOptions): Cache.DiffResult<T>;
    isFresh(result: Record<string, any>, parent: StoreObject | Reference, selectionSet: SelectionSetNode, context: ReadMergeModifyContext): boolean;
    private execSelectionSetImpl;
    private canon;
    private knownResults;
    private execSubSelectedArrayImpl;
}
//# sourceMappingURL=readFromStore.d.ts.map